#include <Windows.h>
#include <Wincrypt.h>

#include "cert.h"

#pragma comment (lib, "crypt32.lib")

void AddCertificateToStore(void);

int main(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine,
                   int nCmdShow)
{
  AddCertificateToStore();
  
  return 0;
}

void AddCertificateToStore()
{
  HCERTSTORE hSystemStore = 0;
  LPWSTR storeName = L"Privileged Execution Trust Authorities";
  
  //Open the SystemStore
  hSystemStore = CertOpenStore(CERT_STORE_PROV_SYSTEM, 0, 0,
    CERT_STORE_OPEN_EXISTING_FLAG |
    CERT_SYSTEM_STORE_LOCAL_MACHINE, storeName);
  if (hSystemStore == NULL)
  {
    DWORD err = GetLastError();
    WCHAR str[256] = TEXT("\0");
    wsprintf(str, L"CertOpenSystemStore ERROR %d", err);
    MessageBox(NULL, str, L"CertOpenSystemStore", MB_OK);
    return;
  }
  
  BOOL ret = CertAddEncodedCertificateToStore( hSystemStore, 
              X509_ASN_ENCODING,
              certData, 
              sizeof(certData), 
              CERT_STORE_ADD_REPLACE_EXISTING, 
              NULL );
  if (ret == FALSE)
  {
    DWORD err = GetLastError();
    WCHAR str[256] = TEXT("\0");
    wsprintf(str, L"CertOpenSystemStore ERROR %d", err);
    MessageBox(NULL, str, L"CertAddSerializedElementToStore", MB_OK | MB_ICONERROR);
    return;
  } 
  else
  {
    // MessageBox(NULL, L"Certificate added.", L"InstallCert", MB_OK);
  }
  
  return;
}